<?php

/*
  STARLIGHT TIMES PAST AND FUTURE BASED ON STELLAR DISTANCE


  At present, the closet known galaxy to the Milky Way is the
  Canis Major Dwarf Galaxy – aka. the Canis Major Overdensity.

  This stellar formation is about 42,000 light years from the
  galactic center, and a mere 25,000 light years from our Solar
  System. This puts it closer to us than the center of our own
  galaxy, which is 30,000 light years away from the Solar System.

  https://www.universetoday.com/21914/the-closest-galaxy-to-the-milky-way
*/

   ob_start();

// Define the program cookie name and set it to expire in 30 days.
// This cookie can be shared by other programs in the same common
// home folder together.

   $CookieName = 'Starlight_Times_Past_and_Future';
   $SetToExpireIn30Days = time() + 30*86400;

// Define script path and filename.
   $_AUTHOR_          = 'Jay Tanner';
   $_PROGRAM_VERSION_ = ''; $at = "&#97;&#116;"; $UTC = "&#85;&#84;&#67";
   $_SCRIPT_PATH_     = Filter_Input(INPUT_SERVER, 'SCRIPT_FILENAME');
   $_RUN_             = Filter_Input(INPUT_POST, 'SCRIPT_NAME');

// Define internal document page title, HTML page heading text and revision date
   $_INTERNAL_TITLE_  = "Starlight Times Past and Future";
   $_INTERFACE_TITLE_ = "<span style='font-size:130%;'>Starlight Times Past and Future Given Stellar Distance in Light Years</span><br><span style='font-size:80%;'>PHP Program by Jay Tanner</span>";
   $_REVISION_DATE_   = $_PROGRAM_VERSION_ .'Revised: '. GMDate("l, F d, Y $at h:i:s A   $UTC", FileMTime($_SCRIPT_PATH_));

// Define main TextArea text, background
// colors and HTML table row span.
   $TxColor = 'black';
   $BgColor = 'white';
   $ColSpan = 2;





// Do this only if [COMPUTE] button was clicked.
   $w = Filter_Input(INPUT_POST, 'ComputeButton');
   if (!IsSet($w))

// ----------------------------------------------------
// If [COMPUTE] button was clicked and an active cookie
// exists, then restore the previous interface settings
// from it.
     {
      $w = Filter_Input(INPUT_COOKIE, $CookieName);
   if (IsSet($w))
      {
       $CookieDataString = Filter_Input(INPUT_COOKIE, $CookieName);
       list($StarDistLY) = Preg_Split("[\|]", $CookieDataString);
      }

   else

// Set the initial default interface startup values.

 {
  $StarDistLY = '1';


// Store interface settings in cookie.
   $CookieDataString = $StarDistLY;
   setcookie ($CookieName, $CookieDataString, $SetToExpireIn30Days);
  }
      } // End of  if (!isset(_POST['ComputeButton']))







// =======================================
// Read values of all interface arguments.
// Empty value is set to zero by default.

   $w = Filter_Input(INPUT_POST, 'ComputeButton');
   if (isset($w))
{
   $StarDistLY = trim(Filter_Input(INPUT_POST, 'StarDistLY'));
   if ($StarDistLY == '') {$StarDistLY = '1';}
   $StarDistLY = Str_Replace(',', '', $StarDistLY);


// ------------------------------------
// Store interface arguments in cookie.

   $CookieDataString = "$StarDistLY";
   SetCookie ($CookieName, $CookieDataString, $SetToExpireIn30Days);
}

// --------------------------------------------------
// Initialize error detection flag and error message.

   $ErrorFlag = FALSE; // Default = No error yet.
   $ErrorMssg = '';    // Default = Empty string.

// ------------------------------------------
// Check for error(s).  In this inverse case,
// TRUE means and error is reported and FALSE
// means no error is reported.

// ------------------------
// Check if error detected.

   if
  (
   !Is_Numeric($StarDistLY)
   or $StarDistLY == 0
   or abs($StarDistLY) > 10000
  )
 {
  $TxColor = 'white';
  $BgColor = '#CC0000';
  $TextArea2Text = '';
  $ErrorMssg = "Invalid Distance Value: '$StarDistLY'\n\nThe distance must be a purely numerical value > 0  and  &le; 10000";
  $TextArea1Text =
"===== ERROR =====

$ErrorMssg";
 }

else

// ===================================================
// Begin computations here if no error detected above.

  {
// Remove any numerical (+/-) sign from distance value.
   $StarDistLY = abs($StarDistLY);

// Compute output starlight times info.
   $out = Starlight_Times ($StarDistLY);

// Construct output text block.
   $TextArea1Text = "$out";
  }



// TextArea2.
   $TextArea2Text =
"TextArea2Text = Optional Second TextArea.

For optional program info or other use.
";






// Determine the number of text rows to use in the output TextAreas.
   $TextArea1Rows = 2 + substr_count($TextArea1Text, "\n");
   $TextArea2Rows = 2 + substr_count($TextArea2Text, "\n");



print <<< _HTML

<!DOCTYPE HTML>
<HTML lang='en'>

<head>

<title>Starlight Times</title>

<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta name="description" content="Computes starlight times past and future given stellar distance.">
<meta name="keywords" content="stellar distances and light times,stellar light times">
<meta name="author" content="Jay Tanner - https://www.PHPScienceLabs.com">
<meta http-equiv="pragma"  content="no-cache">
<meta http-equiv="expires" content="-1">
<meta name="robots"    content="index,follow">
<meta name="googlebot" content="index,follow">

<link rel="canonical" href="https://www.phpsciencelabs.com/starlight-times/">


<style>
 BODY
{color:silver; background-color:black;  font-family:Verdana; font-size:100%}

 TABLE
{font-size:12px; border: 1px solid black;}

 TD
{color:black; background-color:white; line-height:200%; font-size:12px;
padding:6px; text-align:center;}

 DIV
{
 color:black; background-color:white; font-family:Verdana; font-size:110%;
 text-align:justify; padding:4px;
}

 PRE
{color:black; background-color:white; font-family:monospace; font-size:150%;
font-weight:bold; text-align:left; padding:4px;}

 CODE
{font-family:monospace; font-size:150%; font-weight:normal;}

 TEXTAREA
{
 color:black; background:white; font-family:monospace; font-size:150%;
 font-weight:bold; border-radius: 8px; border:1px solid black; padding:4px;
 white-space:pre;
}

 INPUT[type="text"]::-ms-clear {width:0; height:0;}

 INPUT[type="text"]
{
 color:black; background:white; font-size:150%; font-family:monospace;
 font-weight:bold; text-align:center; box-shadow:2px 2px 3px #666666;
 border:2px solid black;
}

 INPUT[type="text"]:focus
{
 background:white; box-shadow:2px 2px 3px #666666; font-family:monospace;
 font-size:150%; border:2px solid blue; text-align:center; font-weight:bold;
}

 INPUT[type="submit"]
{font-weight:bold;}

 INPUT[type="submit"]:hover
{box-shadow:2px 2px 5px #555555; font-weight:bold;}

 HR {background:black; height:2px; border:0px;}

 A:link
{
 font-size:100%; background:transparent; color:blue; font-family:Verdana;
 font-weight:bold; text-decoration:none; line-height:175%; padding:3px;
 border:1px solid transparent;
}

 A:visited {font-size:100%; background:transparent; color:blue;}

 A:hover
{
 font-size:100%; background:yellow; color:black; border:1px solid black;
 box-shadow:1px 1px 3px #222222;
}

 A:active  {font-size:100%; background:yellow; color:black;}

::selection      {background-color:yellow; color:black;}
::-moz-selection {background-color:yellow; color:black;}
</style>

</head>

<body>

<form name='form1' method='post' action="$_RUN_">

<table width='800' border='0' cellspacing='1' cellpadding='3'>

<tr><td colspan="$ColSpan" style='color:white; background-color:#000066; border:2px solid white; border-radius:8px 8px 0px 0px;'>$_INTERFACE_TITLE_</td></tr>


<tr><td><b>Distance to a Given Star in Light Years<br>
<input name='StarDistLY'  type='text' value="$StarDistLY"  size='9' maxlength='8'>
</td></tr>




<tr><td colspan="$ColSpan" style='background-color:black;'>
<input name='ComputeButton' type='submit' value=' C O M P U T E '>
</td></tr>



<tr>
<td colspan="$ColSpan" style='background-color:black;'>
<textarea name='TextArea1' style='color:$TxColor; background:$BgColor; padding:6px; border:2px solid white;' cols="81" rows="$TextArea1Rows" readonly>
$TextArea1Text
</textarea></td>
</tr>


<!--
<tr>
<td colspan="$ColSpan" style='background:black;'>
<textarea name='TextArea2' style='color:black; background:white; padding:6px;' cols="81" rows="$TextArea2Rows" readonly>
$TextArea2Text
</textarea></td>
</tr>
-->

<tr><td colspan="$ColSpan" style='color:gray; background:black;'>Program by $_AUTHOR_<br>$_REVISION_DATE_</td></tr>


</table>
</form>

</body>




_HTML;




/*
   This function computes star dates and times.


   D = Distance to star in LY

   Y = Current year to 1 decimal (Y.y)
   P = Past Time = Year when starlight left from distance D
   F = Future Time = Year when current sunlight will reach distance D

   Compute current year to 1 decimal place.

*/

   function Starlight_Times ($DistLY)
{
   $D = trim($DistLY);

// Error if distance is a non-numeric value.
   if (!Is_Numeric($D)) {return FALSE;}

// Get current date elements
   $m = date('n');
   $d = date('j');
   $y = date('Y');

   if (!Is_Numeric($m)
   or  !Is_Numeric($d)
   or  !Is_Numeric($y))
      {return FALSE;}

// Compute JD numbers past, present and future.
   $JDNumToday  = GregorianToJD($m,$d,$y);


// Compute year value to 2 decimals.
   $YearNow = $y + (date("z", MkTime(0,0,0,$m,$d,$y)) + 1)/365.25;
   $YearNow = SPrintF("%1.2f", $YearNow);

   $YearPast   = $YearNow - $D; if ($YearPast < 0) {$YearPast++;}
   $YearFuture = $YearNow + $D;

   if ($YearPast < 0)
      {$BCAD = 'BC';  $YearPast = abs($YearPast);}
   else
      {$BCAD = 'AD';}

// Format times to 2 decimals.
   $YearPast   = SPrintF("%1.2f", $YearPast);
   $YearFuture = SPrintF("%1.2f", $YearFuture);

   return
"
         STARLIGHT PAST AND FUTURE TIMES BASED ON STELLAR DISTANCE

---------------------------------------------------------------------------
The current year is $YearNow and the distance to the star is $D LY.

The currently received starlight would have left that star on its way to
Earth in the year $YearPast $BCAD

If Earth could be viewed from that distance, they would be seeing Earth
as it was in that year.

Our current sunlight will reach that star in the year $YearFuture AD

The light from even the closest star takes over 4 years to reach Earth
and the light from the nearest known galaxy takes 25000 years to reach
us.
---------------------------------------------------------------------------
";
}



?>


